unit GSamm;

interface

uses Crt;
     type   string_arrayG = array [0..9] of string;
            digitalG      = ( AN , AFF );

     procedure Erma(time : integer);
     function MenueShadow(AnzPunkte : integer;Titel : string_arrayG;LiMi : byte;number : digitalG):integer;
     procedure Aufgerufen(HintFarbe,VordFarbe,Verz : integer ; text : string );
     procedure GraphHint(Nr,Farbe : word);
     function Drehknopf(x,y : integer;StartPos : word):integer;
     function StellKnopf(x,y : integer;StartPos : word):integer;
     procedure WaitToKey(ASCII : byte; Sonder : digitalG);
     function readAbg(x,y,Laenge : integer):real;



implementation

uses Graph;

var  GraphDriver,GraphMode  : integer;
     i                      : integer;

procedure initialize;
begin
    GraphDriver:=detect;
    InitGraph(GraphDriver,GraphMode,'\master\tp5');  {   <--<<    Grafik- }
                                               { verzeichnis mu stimmen. }
    SetBkColor(1);
end;

procedure Linie0(x,y : integer);
begin
    MoveTo(x-8,y+4); LineTo(x-8,y-11);
end;

procedure Linie1(x,y : integer);
begin
    MoveTo(x-8,y+4); LineTo(x+12,y+4);
end;

procedure Linie2(x,y : integer);
begin
    MoveTo(x-8,y+4); LineTo(x-8,y+19);
end;

procedure Linie3(x,y : integer);
begin
    MoveTo(x-8,y+4); LineTo(x-28,y+4);
end;

procedure Erma(time : integer);
begin
    initialize;
    randomize;
    i:=0;
    repeat
      inc(i);
      PutPixel(random(GetMaxX),random(GetMaxY),random(20));
    until i=7000;
    SetColor(12);
    Rectangle(1,1,GetMaxX-3,GetMaxY-3);
    delay(30);
    SetColor(27);
    Rectangle(6,3,GetMaxX-8,GetMaxY-5);
    delay(30);
    SetColor(12);
    Rectangle(11,5,GetMaxX-13,GetMaxY-7);
    delay(30);
    SetTextJustify(CenterText,CenterText);
    SetTextStyle(TriplexFont,HorizDir,9);
    SetColor(7);
    for i:=4 downto 1 do
      OutTextXY((GetMaxX div 2)+(3*i),(GetMaxY div 4)-i,'E R M A');
    SetColor(11);
    OutTextXY(GetMaxX div 2,GetMaxY div 4,'E R M A');
    SetTextStyle(TriplexFont,HorizDir,6);
    SetColor(7);
    for i:=3 downto 1 do
      OutTextXY((GetMaxX div 2)+(3*i),(3*(GetMaxY div 4))-i,'E l e c t r o n i c');
    SetColor(11);
    OutTextXY(GetMaxX div 2,3*(GetMaxY div 4),'E l e c t r o n i c');
    SetColor(12);
    delay(time);
    CloseGraph;
end;


function MenueShadow(AnzPunkte : integer;Titel : string_arrayG;LiMi : byte;number : digitalG):integer;
var  Punkt,MaxPunkt : integer;
     WahlPunkt      : integer;
     X,Y,Breite     : integer;
     Teil1,Teil2    : integer;
     ch             : integer;
     gewaehlt       : boolean;
begin
     IF AnzPunkte<=9 THEN BEGIN
     MaxPunkt:=0;
     for Punkt:=0 to AnzPunkte do begin
        if length(Titel[MaxPunkt]) < length(Titel[Punkt]) then
           MaxPunkt:=Punkt;
     end;
     Breite:=length(Titel[MaxPunkt])+4;
     if number=AN then Breite:=Breite+4;
     If Breite<=70 Then Begin
     TextColor(7); TextBackground(7); clrscr;
     X:=38 - (Breite div 2)+1;
     Y:=12 - ((AnzPunkte*2+1) div 2);
     gotoXY(X,Y);TextBackground(1);TextColor(15);
     write(' ');
     for i:=1 to (Breite-2) do write(''); write(' ');
     gotoXY(X,Y+1);write(' ');
     gotoXY(X+Breite,Y+1); write(' '); TextColor(0); write('');
     TextColor(15);
     gotoXY(X,Y+AnzPunkte*2+2);write(' ');
     for i:=1 to (Breite-2) do write('');write(' ');
     TextColor(0); write('');
     gotoXY(X+2,Y+AnzPunkte*2+3);
     for i:=1 to (Breite+2) do write('');
     Teil1:=(Breite-2-length(Titel[0])) div 2;
     if (2*Teil1) = (Breite-2-length(Titel[0])) then
        Teil2:=Teil1
     else
        Teil2:=Teil1+1;
     Textbackground(4); TextColor(15);
     gotoXY(X+2,Y+1);for i:=1 to Teil1 do write(' ');write(Titel[0]);
     for i:=1 to Teil2 do write(' ');
     TextBackground(1);TextColor(15);
     Wahlpunkt:=1;
     REPEAT
     for Punkt:=1 to AnzPunkte do begin
        gotoXY(X,Y+2*Punkt); write(' ');
        for i:=1 to (Breite-2) do write(' '); write(' ');
        TextColor(0); write(''); TextColor(15);
        gotoXY(X,Y+2*Punkt+1);write(' ');
        if Punkt=WahlPunkt then begin
          TextBackground(1); TextColor(14);
        end;
        if LiMi=0 then begin
           if number=AN then
              write(' ',punkt,'. ')
           else
              write(' ');
           write(Titel[Punkt]);
           if number=AN then
              for i:=1 to (Breite-6-length(Titel[Punkt])) do write(' ')
           else
              for i:=1 to (Breite-3-length(Titel[Punkt])) do write(' ');
        end else begin
           Teil1:=(Breite-2-length(Titel[Punkt])) div 2;
           if (2*Teil1) = (Breite-2-length(Titel[Punkt])) then
              Teil2:=Teil1
           else
              Teil2:=Teil1+1;
           if number=AN then begin
              Teil1:=Teil1-3;
              write(' ',Punkt,'. ');
              Teil2:=Teil2-1;
           end;
           for i:=1 to Teil1 do write(' ');write(Titel[Punkt]);
           for i:=1 to Teil2 do write(' ');
        end;
        if Punkt=WahlPunkt then begin
           TextBackground(1);TextColor(15);
        end;
        write(' '); TextColor(0); write(''); TextColor(15);
     end;
     ch:=-1;
     gewaehlt:=false;
     repeat
       repeat
         ch:=ord(readkey);
         gewaehlt:=(number=AN) and ((ch>48) and (ch<Anzpunkte+49));
       until (ch=0) or (ch=13) or gewaehlt;
       if ch=0 then
         ch:=ord(readkey);
     until (ch=$48) or (ch=$50) or (ch=13) or gewaehlt;
     if (ch<>13) and (not gewaehlt) then begin
        if ch=$50 then begin
           if WahlPunkt=AnzPunkte then
              WahlPunkt:=1
           else
              WahlPunkt:=WahlPunkt+1;
        end else begin
            if WahlPunkt=1 then
               WahlPunkt:=AnzPunkte
            else
               WahlPunkt:=WahlPunkt-1;
        end;
     end;
     UNTIL (ch=13) or gewaehlt;
     End Else
     Wahlpunkt:=-1;
     END ELSE
     WahlPunkt:=-1;
     if gewaehlt then WahlPunkt:=ch-48;
     MenueShadow:=WahlPunkt;
     TextBackground(0); TextColor(7);
end;


procedure Aufgerufen(HintFarbe,VordFarbe,Verz : integer ; text : string );
var   x,y,i,Maxi  : integer;

begin
   if length(text) < 60  then begin
     initialize;
     SetTextJustify(CenterText,CenterText);
     x:=GetMaxX div 2; y:=GetMaxY div 2 -100;
     SetBkColor(HintFarbe);
     Maxi:=100 div length(text);
     if Maxi>10 then Maxi:=10;
     for i:=1 to Maxi do begin
       SetColor(7+i);
       SetTextStyle(TriplexFont,HorizDir,i);
       OutTextXY(x,y+10*i,text);
     end;
     SetColor(VordFarbe); SetTextStyle(TriplexFont,HorizDir,Maxi+1);
     OutTextXY(x,y+(Maxi+1)*10,text);
     delay(Verz);
     CloseGraph;
   end else begin
     sound(100); delay(100);nosound;
   end;
end;


procedure GraphHint(Nr,Farbe : word);
var  PolyPoints    : array [1..5] of PointType;
     x,y,xMax,yMax : integer;
begin
  if (Nr>=0) and (Nr<12) and (Farbe>=0) and (Farbe<25) then begin
    initialize;
    PolyPoints[1].x:=0;       PolyPoints[1].y:=0;
    PolyPoints[2].x:=GetMaxX; PolyPoints[2].y:=0;
    PolyPoints[3].x:=GetMaxX; PolyPoints[3].y:=GetMaxY;
    PolyPoints[4].x:=0;       PolyPoints[4].y:=GetMaxY;
    PolyPoints[5].x:=0;       PolyPoints[5].y:=0;
    SetFillStyle(Nr,Farbe);
    FillPoly(5,PolyPoints);
  end;
  if (Nr=12) and (Farbe>0) and (Farbe<25) then begin
     initialize;
     xMax:=GetMaxX; yMax:=GetMaxY;
     SetBkColor(0); SetColor(Farbe);
     SetTextStyle(SmallFont,HorizDir,4);
     SetTextJustify(LeftText,CenterText);
     x:=0; y:=0;
     repeat
       repeat
         MoveTo(x,y);
         OutText('ERMA');
         x:=GetX;
       until x>=xMax;
       y:=GetY+10;
       x:=0
     until y>=yMax;
  end;
end;


function Drehknopf(x,y : integer;StartPos : word):integer;
var  i : integer;
begin
  if (x>28) and (x<GetMaxX-20) and (y>15) and (y<GetMaxY-19) then begin
     initialize;
     SetColor(4);
     SetFillStyle(SolidFill,4);
     for i:=0 to 3 do FillEllipse(x-2*i,y+i,20,15);
     SetColor(7);
     SetFillStyle(SolidFill,7);
     FillEllipse(x-8,y+4,20,15);
     SetColor(15);
     case StartPos of
       0 : Linie0(x,y);
       1 : Linie1(x,y);
       2 : Linie2(x,y);
       3 : Linie3(x,y);
     end;
     Drehknopf:=StartPos;
  end else Drehknopf:=-1;
end;


function StellKnopf(x,y : integer;StartPos : word):integer;
var  Eingestellt : integer;
     ch          : integer;
begin
    if keypressed then begin
      ch:=ord(readkey);
      if ch=0 then begin
        ch:=ord(readkey);
        if (ch=$4B) or (ch=$4D) then begin
          Eingestellt:=StartPos;
          if ch=$4B then begin
            if Eingestellt=0 then
              Eingestellt:=3
            else
              Eingestellt:=Eingestellt-1;
          end else begin
            if Eingestellt=3 then
              Eingestellt:=0
            else
              Eingestellt:=Eingestellt+1;
          end;
          if Eingestellt=0 then begin
            SetColor(7); Linie1(x,y); Linie3(x,y);
            SetColor(15); Linie0(x,y);
          end;
          if Eingestellt=1 then begin
            SetColor(7); Linie0(x,y); Linie2(x,y);
            SetColor(15); Linie1(x,y);
          end;
          if Eingestellt=2 then begin
            SetColor(7); Linie1(x,y); Linie3(x,y);
            SetColor(15); Linie2(x,y);
          end;
          if Eingestellt=3 then begin
            SetColor(7); Linie2(x,y); Linie0(x,y);
            SetColor(15); Linie3(x,y);
          end;
          StellKnopf:=Eingestellt;
        end else StellKnopf:=ch*(-1);
      end else begin
        if ch>3 then
          StellKnopf:=ch
        else
          StellKnopf:=StartPos;
      end;
    end else StellKnopf:=StartPos;
end;


procedure WaitToKey(ASCII : byte; Sonder : digitalG);
var  ch   : byte;
begin
    if Sonder=AN then begin
      repeat
        repeat
          ch:=ord(readkey);
        until ch=0;
        ch:=ord(readkey);
      until ch=ASCII;
    end else begin
      repeat
        ch:=ord(readkey);
      until ch=ASCII;
    end;
end;


function readAbg(x,y,Laenge : integer):real;
     var  i,n         : integer;
          Komma       : integer;
          Mult        : longint;
          Wert        : real;
          ErstKomma   : boolean;
          ErstNeg     : boolean;
          Ziffer      : array [1..9] of byte;
          ch          : byte;
     begin
         for i:=1 to Laenge do
           Ziffer[i]:=0;
         i:=1;
         Komma:=0;
         ErstNeg:=true;
         ErstKomma:=true;
         gotoXY(x,y);
         repeat
           repeat
             ch:=ord(readkey);
           until ((ch>47) and (ch<58)) or (ch=13) or ((ch=44) and Erstkomma) or (ch=45) or (ch=27);
           if ch<>27 then begin
             if ch<>13 then begin
               if ch=44 then begin
                 Komma:=i;
                 write(',');
                 ErstKomma:=false;
               end;
               if ch=45 then begin
                 gotoXY(x-1,y);
                 if ErstNeg then
                   write('-')
                 else
                   write(' ');
                 ErstNeg:=not ErstNeg;
                 if Erstkomma then
                   gotoXY(x+i-1,y)
                 else
                   gotoXY(x+i,y);
               end;
               if (ch>47) and (ch<58) then begin
                 Ziffer[i]:=ch-48;
                 write(Ziffer[i]);
                 inc(i);
               end;
             end;
           end;
         until (ch=13) or (i>Laenge) or (ch=27);
         if ch<>27 then begin
           i:=i-1;
           Wert:=0;
           Mult:=1;
           for n:=i downto 1 do begin
             Wert:=Wert+Ziffer[n]*Mult;
             Mult:=Mult*10;
           end;
           if (not Erstkomma) then
             for n:=1 to (i-(Komma-1)) do
               Wert:=Wert/10;
           if (not ErstNeg) then Wert:=Wert*(-1);
           ReadAbg:=Wert;
         end else ReadAbg:=1E17;
         { bei Abbruch mit ESC wird 1E17 zurckgegeben }
     end; { function ReadAbg }


end.
