program ad1199_1;

(***************************************
 *  Programm fr die Karte   AD 1199   *
 *                                     *
 *  Standard mit whlb. Mebereichen   *
 ***************************************)

uses crt,graph,AD_MS,GSAMM;

type    real_array       = array [0..7] of real;
const   adresse = $100;
var     Y1,Y2,X1,X2      : real_array;
        S,N,TEMP         : real_array;
        f                : file of real;
        Ende             : boolean;



procedure FestplatteLesen;
var  i  : byte;
     ch : byte;
begin
     assign (f,'AD1199#1.DAT');
     {$I-} reset(f); {$I+}
     if IOResult<>0 then begin
       clrscr; gotoXY(10,10);
       write('Datei  AD1199#1.DAT  nicht gefunden.');
       gotoXY(10,12);
       write('Beenden des Programms mit beliebiger Taste.');
       ch:=ord(readkey);
       if ch=0 then ch:=ord(readkey);
       clrscr;
       exit;
     end;
     for i:=0 to 7 do
         read(f,Y1[i],Y2[i],X1[i],X2[i],S[i],N[i],TEMP[i]);
     close(f);
end;




(*****************************************************************)
(*                        Prozedur Hauptmenu                     *)
(*****************************************************************)
procedure Hauptmenue;
var       ch : byte;
          C  : real_array;



 {---------------------------------------------------------------}
 {      Beginn der Unterprozeduren von Hauptmenu                 }
 {---------------------------------------------------------------}

  procedure spannungen(S,N : real_array);
  var  i  : integer;
       R  : real_array;
  begin
     clrscr;
     gotoXY(15,5);
     writeln('Anzeige der Eingangsspannungen');
     textattr:=black;
     textbackground(7);
     gotoXY(40,25);write(' Ende  = F10 ');
     textattr:=lightgray;
     textbackground(0);
     for i:=0 to 7 do begin
         gotoXY(15,i+8);
         write('Meeingang ',i,' =             mV');
     end;
     repeat
           for i:=0 to 7 do begin
               R[i]:=S[i]*Messen(adresse,i)+N[i];
               gotoXY(35,i+8);
               write('       ');
               gotoXY(35,i+8);
               write(R[i]:4:1);
           end;
           if keypressed then begin
             ch:=ord(readkey);
             if ch=0 then
               ch:=ord(readkey)
             else
               ch:=0;
           end;
           delay(500);
     until ch=68;
  end;




  procedure eichen;
  const  decod       : array [48..55] of byte = (0,1,2,3,4,5,6,7);
  var    ch          : byte;
         remkey      : integer;
         i           : integer;
         EndSchleife : boolean;
         Zurueck     : boolean;


         {***  Unterprozeduren von EICHEN :  ***}

         procedure Nullabgleich(i : integer);
         var  eingegeben : boolean;
         begin
           eingegeben:=FALSE;
           gotoXY(10,10);
           writeln('Eingangsspannung 1 anschliessen - Nullwert ',
                                             'eintasten');
           gotoXY(20,12);writeln('Mit ENTER quittieren !');
           TextBackground(lightgray); TextColor(black);
           gotoXY(10,24);write(' Komma statt Dezimalpunkt -- Eingabe in mV ');
           TextBackground(black); TextColor(lightgray);
           repeat
             Y1[i]:=ReadAbg(20,15,6);
           until Y1[i]<>1E17;
           X1[i]:=Messen(adresse,i);
         end;



         procedure Endwert(i : integer);
         var  eingegeben : boolean;
         begin
           eingegeben:=FALSE;
           gotoXY(10,10);
           writeln('Eingangsspannung 2 anschliessen - Endwert ',
                                             'eintasten');
           gotoXY(20,12);writeln('Mit ENTER quittieren !');
           TextBackground(lightgray); TextColor(black);
           gotoXY(10,24);write(' Komma statt Dezimalpunkt -- Eingabe in mV ');
           TextBackground(black); TextColor(lightgray);
           repeat
             Y2[i]:=ReadAbg(20,15,6);
           until Y2[i]<>1E17;
           X2[i]:=Messen(adresse,i);
         end;
         {*** Ende der Unterprozeduren von Eichen ***}



  begin  (**** Beginn der Prozedur EICHEN ***)
     Zurueck:=FALSE;
     repeat
       clrscr;
       gotoXY(5,5);
       writeln('Vor einer Inbetriebnahme empfiehlt sich ein Abgleich',
                  ' der Meeingnge.');
       gotoXY(5,6);
       writeln('     Dadurch wird die Genauigkeit der Meergebnisse erhht.');
       gotoXY(10,9);
       writeln('>>>>>> Mestelle whlen (0 - 7)    <<<<<<');
       textattr:=black;
       textbackground(7);
       gotoXY(42,9);write(' 0 ');
       gotoXY(15,13);writeln(' Nullabgleich         =  F1 ');
       gotoXY(15,15);writeln(' Endwertabgleich      =  F2 ');
       gotoXY(15,17);writeln(' Messung beenden      = F10 ');
       textattr:=lightgray;
       textbackground(0);
       EndSchleife:=FALSE;
       I:=0;
       repeat
         repeat
           remkey:=ord(readkey);
         until ((remkey<56) and (remkey>47)) or (remkey=0);
         if (remkey<56) and (remkey>47) then begin
           textattr:=black;textbackground(7);
           gotoXY(42,9);write(' ',decod[remkey],' ');
           textattr:=lightgray;textbackground(0);
           I:=decod[remkey];
         end else if (remkey=0) then begin
           clrscr;
           EndSchleife:=TRUE;
           remkey:=ord(readkey);
           case remkey of
             59 : Nullabgleich(i);
             60 : Endwert(i);
             68 : Zurueck := TRUE;
           end;
         end else;
       until EndSchleife;
     until Zurueck;
     for i:=0 to 7 do begin          (* Koeffizienten der Eichgeraden*)
         if (X1[i]=X2[i]) or (Y1[i]=Y2[i]) then begin
           clrscr; gotoXY(10,10);
           write('Abbruch wegen Abgleichfehler');
           gotoXY(10,12);
           write('Bitte Taste drcken');
           ch:=ord(readkey);
           if ch=0 then ch:=ord(readkey);
           clrscr;
           exit;
         end;
         S[i]:=(Y2[i]-Y1[i])/(X2[i]-X1[i]);
         N[i]:=Y1[i]-S[i]*X1[i];
     end;                                       (* berechnet *)
     assign(f,'AD1199#1.DAT'); (* auf Festplatte speichern *)
     erase(f);
     rewrite(f);
     for i:=0 to 7 do
         write(f,Y1[i],Y2[i],X1[i],X2[i],S[i],N[i],TEMP[i]);
     close(f);                  (* Ende Festplattespeichern *)
  end;    (*** Ende der Prozedur Eichen ***)

  {---------------------------------------------------------------}
  {           Ende der Unterroutinen von Hauptmenu                }
  {---------------------------------------------------------------}




begin  { ******** BEGINN der Prozedur HAUPTMENU ********** }
     clrscr;
     gotoXY(15,4);
     highvideo;
     writeln('HAUPTMEN');
     gotoXY(15,8);
     textattr:=black;
     Textbackground(7);
     writeln(' Spannungen anzeigen    =  F1 ');
     gotoXY(15,10);
     writeln(' Meeingnge eichen     =  F2 ');
     gotoXY(15,12);
     writeln(' Messung beenden        = F10 ');
     Textbackground(0);
     textattr:=lightgray;
     repeat
       ch:=ord(readkey);
     until ch=0;
     repeat
       ch:=ord(readkey);
     until (ch=59) or (ch=60) or (ch=68);
     case ch of
          59 : Spannungen(S,N);
          60 : Eichen;
          68 : Ende:=TRUE;
     end;
end;   { ********* Ende der Prozedur Hauptmenu ********** }



(*****************************************************************)
(*                      HAUPTPROGRAMM                            *)
(*****************************************************************)
BEGIN
     clrscr;
     PORT[adresse]:=$00; (* Initialisierung *)
     FestplatteLesen;
     Ende:=FALSE;
     repeat
       hauptmenue;
     until Ende;
     clrscr;
END.
